
extern Global(Boolean) CurCurve;
Global(void) ActivateCurve(void);
Global(void) DeactivateCurve(Boolean full);
Global(void) SelectCurve(Int2);
Global(Boolean) SelectCurve_Status(Int2);
Global(Int2) RedrawCurve(void);

Global(void) BuildTypeGraph(MenU mParent);
Global(void) DestroyTypeGraph(void);

#if DEB_CT
  Global(void) Debug_CurveTypes(Int2);
#endif

Global(Int2) Decoder(VoidPtr point, Int2 oper);

Global(void) ForwardProc(Int2 index);
Global(void) BackwardProc(Int2 index);
Global(Boolean) FBProc_Status(Int2 index);
Global(void) ContinueProc(Int2 index);
Global(Boolean) ContinueProc_Status(Int2 index);

extern Global(MenuDesc) TypeMenuDesc;

Global(void) FilterOptProc(Int2 index);
Global(Boolean) FilterOptProc_Status(Int2 index);

Global(void) DeleteFilters(DataLibPtr dl);

extern Global(Int2) curveCurNum;

Global(Int2) GetTypeId(Int2 n);

Global(Boolean) IsDimGMore1(void);
Global(void) SetDimGMore1(Boolean b);

Global(CharPtr) GetSPname(Pointtype localtype, Boolean Full);

enum TypeHelp {
  TH_INITPOINT,
  TH_CURVE,
  TH_STARTER,
  TH_GENERATOR
};
Global(CharPtr) TypeHelpInfo(enum TypeHelp kind);

Global(void) ReadSPList(Int2Ptr num, DataLibPosPtr PNTR list);
Global(void) FreeSPList(Int2 num, DataLibPosPtr list);
Global(void) ReadVAList(Int2 num, ByteStorePtr PNTR PNTR list);
Global(void) WriteVAList(Int2 num, ByteStorePtr PNTR list);
Global(void) FreeVAList(Int2 num, ByteStorePtr PNTR list);

typedef void (PNTR EnumSpecialPointsCallback)(CharPtr Title,
					     CharPtr Label,
					     Int2 Type);
Global(void) EnumSpecialPoints(EnumSpecialPointsCallback cb);

Global(void) SelectPointProc(Int2 index);
Global(Boolean) SelectPointProc_Status(Int2 index);

Global(void) DeleteCurve(DataLibPtr dl);

Global(Boolean) SetSpecialPoint(FilePtr curvePtr, Int2 pointNum);

Global(void) RedrawCurveProc(Int2 index);

Global(void) PauseOptProc(Int2 index);
Global(Boolean) PauseOptProc_Status(Int2 index);

#include "curve0.h"		/* CurrentCurveData structure */

extern Global(CurrentCurveData) ccd;

Global(void) RedrawKey(Char key);

Global(Boolean) TypesSet_Status(Int2 index);

Global(Uint1) ClassGlobToLoc(Int2 RealId);
Global(Int2) GetLocalClasses(Uint2Ptr PNTR readIds);

Global(void) InvalidateBifData(void);

Global(CharPtr) FindAndOpenDescFile(DataLibPtr dgm, CharPtr section);

Global(void) ExportDefStaGen(DataLibPtr dgm, FILE PNTR out);
Global(void) ImportDefStaGen(DataLibPtr dgm, FILE PNTR in);
Global(void) ExportFilter(DataLibPtr dgm, CharPtr DescFile, FILE PNTR out);
Global(void) ImportFilter(DataLibPtr dgm, CharPtr DescFile, FILE PNTR in);
Global(void) ExportCurve(DataLibPtr dgm, FILE PNTR out, Int2 outlevel);
Global(void) ImportCurve(DataLibPtr dgm, FILE PNTR in, Int2 outlevel);

typedef void (*CallbackCR)(int sig);
Global(void) StartCR(jmp_buf PNTR pretenv, CallbackCR callback);
Global(void) EndCR(void);
