/*
   Reads titles of various controls
*/

#include "common.h"

#include "text.h"

Global(CharPtr PNTR) ArchiveTxt=NULL;	/* used locally in archive.c */

Global(CharPtr PNTR) CurveTxt=NULL;	/* used locally in curve.c */

Global(CharPtr PNTR) DatalibTxt=NULL;	/* used locally in datalib.c */

Global(CharPtr PNTR) DiagramTxt=NULL;	/* used locally in diagram.c */

Global(CharPtr PNTR) DialogTxt=NULL;	/* used locally in dialog.c */

Global(CharPtr PNTR) FunctionTxt;	/* used locally in function.c */

Global(CharPtr PNTR) MainwndTxt=NULL;	/* used locally in mainwnd.c */

Global(CharPtr PNTR) ParamTxt=NULL;	/* used locally in param.c */

Global(CharPtr PNTR) PointTxt=NULL;	/* used locally in point.c */

Global(CharPtr PNTR) VisualTxt=NULL;	/* used locally in visual.c */

Global(CharPtr PNTR) UserTxt=NULL;	/* used locally in usertest.c */

Local(void) readTitles(CharPtr PNTR PNTR ptr, Int2 n) {
  CharPtr p,q;
  Int2 i;
  Char buf[80];
  *ptr=(CharPtr PNTR)_MemNew(sizeof(CharPtr)*n);
  for (i=0; i<n; i++) {
    GetLine(buf);
    p=StrChr(buf,'=');
    if (p) p++; else p=buf;
    StrTrim(p);
    q=StrStr(p,STR_EMPTY);
    if (q) *q='\0';
    do {
      q=StrStr(p,STR_NL);
      if (q) *q='\n'; else break;
    } while (1);
    (*ptr)[i]=_StringSave(p);
  }
}

Local(void) freeTitles(CharPtr PNTR PNTR p, Int2 n) {
  Int2 i;
  if (*p)
    for (i=0; i<n; i++) _MemFree((*p)[i]);
  *p=_MemFree(*p);
}

typedef struct {
  CharPtr key;
  CharPtr PNTR PNTR texts;
  Int2 num;
} SourceText;

Local(SourceText) Texts[]={
  {SECPRF"archive",	&ArchiveTxt,	0},
  {SECPRF"curve",	&CurveTxt,	0},
  {SECPRF"datalib",	&DatalibTxt,	0},
  {SECPRF"diagram",	&DiagramTxt,	0},
  {SECPRF"dialog",	&DialogTxt,	0},
  {SECPRF"function",	&FunctionTxt,	0},
  {SECPRF"mainwnd",	&MainwndTxt,	0},
  {SECPRF"param",	&ParamTxt,	0},
  {SECPRF"point",	&PointTxt,	0},
  {SECPRF"visual",	&VisualTxt,	0},
  {SECPRF"userfunc",	&UserTxt,	0}
};

Global(void) ReadTexts(void) {
  Int2 i;
  GetParam(SFS_FILES,"INITFILE");
  if (DescOpen(ParBuf)) {
    for (i=0; i<DIM(Texts); i++)
      if (FindLine(Texts[i].key)>=0) {
	readTitles(Texts[i].texts,Texts[i].num=CountLines());
      }
    DescClose();
  } else {
    myWarning("CT_OPEN",ParBuf);
    return;
  }
}

Global(void) FreeTexts(void) {
  Int2 i;
    for (i=0; i<DIM(Texts); i++)
      freeTitles(Texts[i].texts,Texts[i].num);
}

